/*
  - RUTA: /parrillaJefatura
  - PARRILLA {{channel}} - JEFATURA
  - MUESTRA PROGRAMACION E IMPRESION
*/
<template>
	<div>
		
		<header style="margin: 10rem 1rem 3rem">
			<ReturnButton :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
		</header>
		<!-- COMPONENTE TITULO -->
		<div class="margin-title-grid">
			<app-title :Title="`PARRILLA ${chanelTransmission} - JEFATURA`" bgColor="background-color: #4A4A4A !important"> </app-title>
		</div> 
		<el-main>
			<h1 class="title-Schedule">Programación de la {{dateString}}</h1>
			<!-- Fecha y botones -->
			<el-row class="margin-date-btn-in-grid-style" type="flex" justify="space-between">
				<div class="flex-content">
					<div style="margin-right: 50px;">
						<p style="margin-top: 0.6rem;" class="title">{{dateString}}</p>
					</div>
					<el-date-picker
						class="date-head flex element-bloq-center"
						v-model="dateSearch"
						type="date"
						format="dd/MM/yyyy"
						value-format="timestamp"
						placeholder="Escoja una semana"
						@change="setWeek">
					</el-date-picker>
				</div>
				<div class="flex element-bloq-center">
					<el-tooltip class="item" effect="dark" content="Guardar" placement="bottom">
						<el-button @click="saveGrid" icon="icon-save" class="btn_icons_p font-size-25" type="iconGrid" :disabled="isDisabledBtn"></el-button>
					</el-tooltip>
					<el-tooltip class="item" effect="dark" content="Imprimir" placement="bottom">
						<el-button @click="printPage" class="margin_l_35 btn_icons_p font-size-25" icon="icon-print" type="iconGrid" plain :disabled="isDisabledBtn"></el-button>
					</el-tooltip>

        	<div v-if="styleBtnAproved.isShow == false" class="text-green margin_l_35 flex element-bloq-center">
						<i class="icon-check font-size-18" style="margin-right: 8px"></i>
						<p class="font-size-17 textBold"> APROBADO </p>
					</div>
					<div v-else>
						<p class="font-size-17 margin_l_35 flex text-red-color textBold"> PENDIENTE </p>
					</div>

				</div>
			</el-row>
			<br>
			<div class="flex-content just-center">
				<!--Schedule-->
				<gridSchedule :hours="timeForDay" boxSyleBorder="box_style_border_left" borderSquare="box_style_border_left"/>
				<!--Content-->
				<div>
					<gridDays :haveRef="true" :days="generateDays()"/>

					<div class="grid-programs" ref="contenedor">
						<div v-for="(program, index) in orderByProgram" :key="index" class="grid-byProgram" :ref="`cell-${index}`" >
							<!-- _______ Header-Program ________ -->
							<div class="flex justify position-z-index" >
								<div class="programDuration" :class="[durationProgramHeader(program.programByDay)]">
									<span>{{calculateScheduleHours(program.programPrincipal.scheduleStartHour, program.programPrincipal.scheduleStartMin)}}</span>
									-
									<span>{{calculateScheduleHours(program.programPrincipal.scheduleEndHour, program.programPrincipal.scheduleEndMin)}}</span>
								</div> 
								<div style="position: relative">
									<i style="position: absolute" class="el-icon-circle-plus text-orange" @click="openModal(program)" :class="[durationProgramHeaderIcon(program.programByDay)]"></i>
									<div class="bg-icon-style" :class="[durationProgramHeaderIcon(program.programByDay)]"></div>
								</div>
							</div>
							<div>
								<!-- program.programPrincipal.materialType == 'Producción Nacional'? 'text-orange' : 'text-blue-color',  -->
								<div class="principalTitle work-break text-blue-color" v-bind:class="[`${durationProgramTitle(program)}`]" v-if="program.programPrincipal.typeOfContent !== 'Largometrajes' &&  program.programPrincipal.typeOfContent !== 'LARGOMETRAJES'">
									<p>{{ program.programPrincipal.programTitle }}</p>
									<span :class="[isClassificationFilmsShow(program)]" class="padding-left-5" v-if="program.programPrincipal.isClasification && program.programPrincipal.classification &&program.programPrincipal.classification !== ''" :style="{color: program.programPrincipal.clasificationColor}" >{{ isHaveClassification(program.programPrincipal.classification) }}</span>
               					</div>
								   
								<!-- Titulo del programa para largometrajes -->
								<div v-else :class="[sizeOfDuration(program.programPrincipal)]">
									<p class="text-orange principalTitle work-break" :class="[durationProgramTitleLargometraje(program.programPrincipal), sizeOfDuration(program.programPrincipal)]">"{{ program.programPrincipal.programTitle }}"</p>
									<p class="principalTitle text-blue-color work-break" :class="[durationProgramTitle(program)]">{{ program.programPrincipal.materialTitle }}<span :class="[isClassificationFilmsShow(program)]" class="padding-left-5" v-if="program.programPrincipal.isClasification" :style="{color: program.programPrincipal.clasificationColor}" >{{ isHaveClassification(program.programPrincipal.classification) }}</span>
										<!-- CLASIFICACION -->
									</p>
									
								</div>

								<div class="principalTitle mt-2">
										<!-- _________  Temporada  __________ -->
										<span v-if="program.programPrincipal.isTemporada && program.programPrincipal.materialHasChapter == 'Si' &&program.programPrincipal.season != '' && program.programPrincipal.season != null" :style="{color: program.programPrincipal.seasonColor}" class="text-ligth"> {{ program.programPrincipal.season }}° TEMPORADA </span>
										<p :style="{color: program.programPrincipal.codProviderColor}" style="letter-spacing: -0.5px; font-weight: 100" v-if="program.programPrincipal.IsCodProvider && isLargometraje(program.programPrincipal.typeOfContent) " >{{ isHaveContent(program.programPrincipal.codeFeatureFilm) }}</p>
									<div style="margin-top: 1rem" v-if="program.programPrincipal.generalNoteBoss && program.programPrincipal.generalNoteBoss !== ''" class="flex-content justify-content-center general-note-style work-break" v-html="program.programPrincipal.generalNoteBoss"> <br></div>
									<div style="margin-top: 1rem" v-if="program.programPrincipal.generalNote && program.programPrincipal.generalNote !== ''" class="flex-content justify-content-center general-note-style work-break" v-html="program.programPrincipal.generalNote"> <br></div>
									<!-- PRECIO DEL MATERIAL - LARGOMETRAJES -->
									<div :style="{color: program.programPrincipal.unitPriceColor}" v-if="program.programPrincipal.isUnitPrice">
										<span v-if="program.programByDay[0].chapters[0].priceByChap">
											{{isPrice(program.programByDay[0].chapters[0].priceByChap)}}
										</span>
									</div>

								</div>
								
							</div>

							<div class="boxAllDays">
								<!-- tengo mas de un dia -->
								<div class="boxByDay" v-for="(day, index) in program.programByDay" :key="index" :style="`grid-column: ${index+1} / span 1; backgroundColor: ${day.bgColorByProgram}`">
									<div class="contentBoxByChapter">
										<div :class="[day.chapters.length == 1 ? 'contentBoxByChapter' : '', 'box_content_chap']">
											<div v-if="day.nota && day.nota !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.nota" ></div>
											<div v-if="day.noteDay && day.noteDay !== '' " class="note work-break padding-0-10 font-size-14" v-html="day.noteDay" ></div>
											<div class="boxByChapterHead" v-for="(chapter, i) in day.chapters" :key="i" :class="[day.IsCap && !day.Estado ? 'width_100' : 'width_auto']">
												<div style="width: auto; max-width: 100%;" class="boxDataByChapter" :class="[day.chapters.length >=3 ? 'font-size-14': '']">
													<!-- NÚMERO DE CAPITULO -->
													<p class="pr-2 d_inline_block" v-if="day.IsCap" :style="{color: day.chapterColor}">{{ chapter.numChapter }}</p>
														<p v-if="day.EstTemp && chapter.seasonInfo == 'Inicio de Temporada'" :style="{color: day.seasonStateColor}" class="mb-5 d_inline_block"> Inicio de Temp.</p>
														<p v-if="day.EstTemp && chapter.seasonInfo == 'Fin de Temporada'" :style="{color: day.seasonStateColor}" class="text-red-color mb-5 d_inline_block"> Fin de Temp.</p>
														<!--  PRECIO POR PASADA DE LARGOMETRAJES  -->		
														<p v-if="isPricePassForCap(day.IsPricePass) && isLargometraje(program.programPrincipal.typeOfContent)"  :style="{color: day.pricePassColor}">
															{{isPrice(chapter.priceByPass)}}
														</p>
														<!-- PRECIO POR PASADA DE LOS CAPITULOS -->
														<!-- Boolean(day.pricePassChapter) && chapter.priceByPass !== '' -->
														<p :style="{color: day.pricePassChapterColor}" class="padding-right-5 d_inline_block" v-if="isPricePassForCap(day.pricePassChapter) && !isLargometraje(program.programPrincipal.typeOfContent)">
															<span v-if="isPricePassForCap(chapter.priceByPass)" >
																{{isPrice(chapter.priceByPass)}}
															</span>
														</p>

														<!-- PRECIO UNITARIO DE LOS CAPITULOS -->
														<p v-if="isPricePassForCap(day.priceChapter) && !isLargometraje(program.programPrincipal.typeOfContent)" class="padding-right-5 d_inline_block" :style="{color: day.priceChapterColor}">
															<span v-if="isPricePassForCap(day.priceChapter)">
																{{isPrice(chapter.priceByChap)}}
															</span>
														</p>

														<!-- ESTADO POR CAPITULO -->
														<p v-if="day.Estado && chapter.status !== ''" class="statusByChapterText d_inline_block">
															<span v-if="chapter.rerun" :style="{color: day.rerunChapterColor}">Rerun </span> <span v-if="chapter.rerun && chapter.estreno">-</span>
															<span v-if="chapter.estreno" :style="{color: day.stateChapterColor}"> Estreno </span> 
															<span v-if="chapter.ongoing" class="text-celeste"> {{ '(ONGOING)'}} </span> 
															<span v-if="day.chapters.length>1 && day.chapters.length-1 !== i">/</span>
														</p>

													<!-- ACTORES -->
													<div v-if="isLargometraje(program.programPrincipal.typeOfContent) && (program.programPrincipal.firstActor !== '' || program.programPrincipal.secondActor !== '')" :class="[sizeTextActors(program.programPrincipal)]">
														<p v-if="program.programPrincipal.firstActor !== ''" class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px"> {{ program.programPrincipal.firstActor }} </p>
														<p v-if="program.programPrincipal.secondActor !== ''" class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px"> {{ program.programPrincipal.secondActor }} </p>
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<gridDays :days="generateDays()"/>
				</div>

				<!--Schedule-->
				<gridSchedule :hours="timeForDay" boxSyleBorder="box_style_border_rigth" borderSquare="box_style_border_rigth"/>
			</div>
		</el-main>

	  <!-- Modal  -->
		<ModalContentComponent 
			:show-dialog.sync="modalInfo"  v-if="modalInfo"
			:programSelected="programSelected"
			:closeModal="closeModal"
			:saveInfoModal="saveInfoModal"
			:isDayAutoSelect="this.dayAutoSelect"
			ref="modalComponent"
			:isShowOptionsModal="true"
			:days="allDiasByProgram"
			/>


    <!-- modal de guardar -->
      <el-dialog :visible.sync="modalGuardar"
        width="33%"
        center
        :close-on-press-escape="false"
        :show-close="false"
        custom-class="dialog-orange"> 
        <el-row >
        <el-col :span="5" class="text-center"><img src="../../../assets/images/happy.svg"  alt="emoticon"></el-col>
        <el-col :span="18" :offset="1">
          <p style="margin-bottom: 0.5rem"><strong> ¡Buen trabajo! </strong></p>
          <p> La parrilla ha sido guardada. </p>        
        </el-col>
      </el-row>
      </el-dialog>

      <!-- MODAL BOTON DE RETROCEDER -->
      <AppModal :show-dialog.sync="returnButtonModal"  v-if="returnButtonModal" nameClass="dialog-red"  :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
        :parrafo="'Si sales de la parrilla sin GUARDAR la información se perderá.'" v-on:btnEvent="returnButtonModal = false" @btnEvent="retroceder" v-on:eventBtn="returnButtonModal = false"
        btn1="SALIR"  btn2="SEGUIR AQUÍ" classBtn1="border-red" typeBtn1="danger">
      </AppModal>

	</div>
</template>

<script>
import ModalContentComponent from './components/ModalContent'
import gridSchedule from '@/components/grid/gridSchedule'
import ReturnButton from '@/components/ReturnButton.vue'
import gridDays from '@/components/grid/gridDays'
import Title from '@/components/Title.vue'
import { sizeLetttersAboutProgram, calculateSchedule, sizeLetttersAboutProgramCompare } from '@/utils/calculateSizeLetters.js'
import { getFirstDay, convertNumberFormatUsd } from '@/utils/calculateTime.js'
import { addingZerosToTheDay, convertFormatDayForCrusses, convertHourDate} from '@/utils/calculateTimePrograms.js'
import { modelProgramByDay, daysSpecific, setChooseDefaultDaySelect } from '@/utils/util.js'
import { mapState, mapGetters } from 'vuex'
import { months } from '@/enums.js'
import { HTTP } from '@/main.js'
import AppModal from '@/components/AppModal.vue'

export default {
	components: {
		'app-title': Title,
		ReturnButton,
		ModalContentComponent,
		gridSchedule,
    gridDays,
    AppModal
	},
	data () {
		return {
      returnButtonModal: false,
			dataTable: '',
			dateSearch: '',
			firstDayOfWeek: '',
			firstDay: '',
			secondDay: '',
			thirdDay: '',
			fourthDay: '',
			fifthDay: '',
			sixthDay: '',
			lastDay: '',
			month: '',
			month2: '',
			year: '',
			year2: '',
			startDate: '',
    		endDate: '',
			orderByProgram: [],
			idOfPrograms: [],
			hour: 5,
			minute: 0,
			contentHtml: '',
			dateString: '',
			modalInfo: false,
			programSelected: {},
			transmission: [],
			allDiasByProgram: [],
			timeForDay: [],
			isSelectColor: false,
			checkAllDays: [],
			changeStatus: '',
			clasificationColor: '',
			notShowSchedule: false,
			dataAllWeek: [],
			modalGuardar: false,
			allProgramsWithGrid: [],
			chanelTransmission: this.$localStorage.get('channelTransmition'),
			dayAutoSelect: []
		}
	},
	sockets:{
		updateGridPreliminary(weeks){
			if(weeks.includes(this.dateString))
				this.getWeek(this.dateString);
		},
		programarParrillaRegular(weeks){
			if(weeks.includes(this.dateString))
				this.getWeek(this.dateString);
		}
	},
	mounted(){
		let printView = false;
		let alturas = []
		let alturasImprimir=[]
		let alturasAux=[];
		for(let i=1; i<=288; i++){alturas.push['20px']};
		let templateRows = alturas.join(' ');
		const items = document.querySelectorAll('.grid-schedule');
		const boxes = document.querySelectorAll('.box_style');
		const grids = document.querySelectorAll('.grid-programs')
		boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
		grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
		

		window.addEventListener('afterprint',()=>{
			// console.log('luego de imprimir')
			printView = false;
			alturas = JSON.parse(JSON.stringify(alturasAux));
			templateRows = alturas.join(' ');
			boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
			grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
		})

		window.addEventListener('beforeprint',()=>{
			// console.log('antes de imprimir')
			printView = true;
			setTimeout(()=>{
				alturasAux = JSON.parse(JSON.stringify(alturas));
				alturas = alturas.map(altura=>Math.floor(parseInt(altura)/3)+'px')
				templateRows = alturas.join(' ');
				boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
				grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			},100)
			setTimeout(()=>{
				items.forEach(item=>{
					let currentStyle= item.getAttribute('style').split(';')[0];
					item.setAttribute('style',currentStyle);
				},100)
			})
			
		})

		var ro = new ResizeObserver( entries => {
			if(printView) return;
			for (let entry of entries) {
				const cr = entry.contentRect;
				const hg = parseInt(cr.height);
				let alturaUnica = parseInt(entry.target.style.gridRow);
				// console.log(alturaUnica);
				let calculateHeigth = Math.floor((Math.floor(hg)+3)/3)
				for(let j=alturaUnica -1; j<= alturaUnica+1; j++){
					alturas[j]= calculateHeigth+'px';
				}
				templateRows = alturas.join(' ');
				// console.log(templateRows);
				boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
				grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			}
		});

		items.forEach(item=>ro.observe(item))
	},
	methods: {
		isPricePassForCap(val) {
			let type = typeof(val)
			let response
			if(type == "string") {
				response = val == '' || val == 'false' ? false : true
			} else {
				response = val
			}
			return response
		},
		sizeTextActors(data) {
			const {firstActor, secondActor} = data
			let time = this.calculateTime(data)
			let style
			if(time <= '01:00:00') {
				style = 'font-i-12 pb-1'
			} else if(time > '01:00:00' && time <= '02:00:00') {
				style = 'font-i-14 pb-1'
			} else {
				style = 'font-i-16 pb-1'
			}
			let firstActorLength = firstActor ? firstActor.length : 0
			let secondActorLength = secondActor ? secondActor.length : 0
			return (firstActorLength + secondActorLength) < 14 ? `${style} style_actors` : style
			// return style
		},
		retroceder () {
			this.$router.push({ name: 'views'})
		},
		isShowContent(price, typeOfContent) {
			if(price && typeOfContent !== 'Largometrajes'){
				return true
			} else if(price && typeOfContent !== 'LARGOMETRAJES') {
				return true
			} else {
				return false
			}
		},
		isPrice(val) {
			if(val && val !== '') {
				return `USD ${this.getFormat(val)}`
			} 
			// else {
			// 	return 'USD 0.00'
			// }
		},
		isHaveContent(val) {
			let value
			if(val && val !== '') {
				value = `(${val})`
			} else {
				value = ''
			}
			return value
		},
		isClassificationFilmsShow(program) {
			const data = this.calculateTime(program.programPrincipal)
			let counterDays = program.programByDay.length
			return counterDays >=2 ? 'textCollapse' : 'd-inline-block'
			// return data >= '01:00:00' ? 'textCollapse' : 'd-inline-block'
		},
		sizeOfDuration(value) {
				let response = this.calculateTime(value)
				return response <= '00:45:00' ? 'margin-0' : ''
			},
		sizeSeason(value) {
				const data = this.calculateTime(value)
				let style
				if(data <= '00:05:00') {
					style = 'font-size-11'
				} else if (data > '00:05:00' && data <= '00:30:00') {
					style = 'font-size-14'
				} else if(data > '00:30:00' && data <= '01:00:00') {
					style = 'font-size-16'
				} else {
					style = 'font-size-18'
				}
				return style
			},
		getFormat (valor) {
			if(valor === 'Cortesía' ) {
				return valor
			} else {
				return valor ? convertNumberFormatUsd(Number(valor)) : ''
			}
		},
		isLargometraje(value) {
			if(value == 'Largometrajes' || value == 'LARGOMETRAJES') {
				return true
			} else {
				return false
			}
		},
		saveInfoModal( programSelected, saveDays, changeStatus, refTextArea, nota, datosModal ) {
			console.log("programSelected",programSelected);
			console.log({programSelected, saveDays, changeStatus, refTextArea, nota, datosModal})
			const {typeOfContent} = programSelected
			let conditionalHaveCaps = programSelected.materialHasChapter && programSelected.materialHasChapter == "Si" && typeOfContent && (typeOfContent !== 'LARGOMETRAJES' || typeOfContent !== "Largometraje")? false : true
			
			let isLargometraje = typeOfContent && (typeOfContent == 'LARGOMETRAJES' || typeOfContent == "Largometrajes") ? true : false

			if(this.isLargometraje(typeOfContent)) {
				saveDays.map((day, i, arr) => {
					this.allDiasByProgram.map((program, i, arr ) => {
						if (program.completeDate.includes(day)) {
							program.isClasification = false
							program.Estado = false
							program.isUnitPrice = false
							program.IsCodProvider = false
							program.IsPricePass = false
							this.programSelected.IsCodProvider = false
							this.programSelected.IsPricePass = false 
							this.programSelected.isUnitPrice = false 

							this.$set(program, "bgColorByProgram", changeStatus )
							datosModal.map((dato, i, arr ) => {
								if(dato.title == "Clasificación") {
									//  && dato.active
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
									dato.color = programSelected.materialExisting == 'Si' ?  this.programSelected.stringMaterialType == 'Producción Nacional' ? '#993300' : '#FF0000'  : this.programSelected.materialType == 'Producción Nacional' ? '#993300' : '#FF0000'
									}
									this.$set(program, "isClasification", dato.active )
									this.$set(program, "clasificationColor", dato.color)
									this.$set(this.programSelected, "isClasification", dato.active )
									this.$set(this.programSelected, "clasificationColor", dato.color)
								}
								if(dato.title == "Precio del Material" && dato.active) {
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										dato.color =  '#219653'  
									}

									this.$set(this.programSelected, "isUnitPrice", dato.active )
									this.$set(this.programSelected, "unitPriceColor", dato.color)
									this.$set(program, "isUnitPrice", dato.active )
									this.$set(program, "unitPriceColor", dato.color)
								}
								
								if (dato.title == 'Código de proveedor') {
									//  && dato.active
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										// dato.color =  '#000000'  
										dato.color = '#000099'
									}
									// #000099
									this.$set(program, 'IsCodProvider', dato.active)
									this.$set(program, "codProviderColor", dato.color)
									this.$set(this.programSelected, 'IsCodProvider', dato.active)
									this.$set(this.programSelected, "codProviderColor", dato.color)
								} 
								if (dato.title == 'Precio por pasada' && dato.active) {
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										dato.color =  'rgb(8, 120, 18)'  
									}
									this.$set(program, 'IsPricePass', dato.active)
									this.$set(program, 'pricePassColor', dato.color)
								} 
								if(dato.title == 'Estado' && dato.active) {
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										// let color =  program.chapters[0].rerun == true ? '#FF0000' :  ''
										let color =  this.isLargometraje(typeOfContent) ? '#FF0000': '#000099'
										let color2 = program.chapters[0].estreno == true ? '#FF0000' :  ''
										this.$set(program, "rerunChapterColor", color )
										this.$set(program, "stateChapterColor", color2 )
									} else {
										this.$set(program, "stateChapterColor", dato.color)
										this.$set(program, "rerunChapterColor", dato.color )
									}

									this.$set(program, "Estado", dato.active )
								}
								let conditionalDays = daysSpecific(this.allDiasByProgram)
								if(this.allDiasByProgram.length >= 2 && saveDays.length == conditionalDays.length) {
									this.$set(programSelected, "generalNoteBoss", 	this.noteDiv(refTextArea, nota))
									this.$set(program, "generalNoteBoss", this.noteDiv(refTextArea, nota))
								} else {
									this.$set(program, "noteDay", this.noteDiv(refTextArea, nota))
								}
							})
						}
					})
				})
			} else {
				this.programSelected.isClasification = false
				this.programSelected.isTemporada = false
				saveDays.map((day, i, arr) => {
					this.allDiasByProgram.map((program, i, arr ) => {
						if (program.completeDate.includes(day)) {
							program.IsCap = false
							program.Estado = false
							program.EstTemp = false
							program.priceChapter = true
							this.$set(program, "bgColorByProgram", changeStatus )
							datosModal.map((dato, i, arr) => {      					
								if(dato.title == "Clasificación" && dato.active) {
                  
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
                    					dato.color = programSelected.materialExisting == 'Si' ?  this.programSelected.stringMaterialType == 'Producción Nacional' ? '#993300' : '#FF0000'  : this.programSelected.materialType == 'Producción Nacional' ? '#993300' : '#FF0000' 
										this.$set(this.programSelected, "clasificationColor", dato.color )
										this.$set(program, "clasificationColor", dato.color )
									}
									else {
										this.$set(this.programSelected, "clasificationColor", dato.color)
										this.$set(program, "clasificationColor", dato.color )
									}
									this.$set(this.programSelected, "isClasification", true )
									this.$set(program, "isClasification", true )
								}

								if(dato.title == "N° Temporada" && dato.active) {
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										let color =  '#000099' 
										this.$set(this.programSelected, "seasonColor", color )
										this.$set(program, "seasonColor", color )
									}else {
										this.$set(this.programSelected, "seasonColor", dato.color)
										this.$set(program, "seasonColor", dato.color )
									}
									this.$set(this.programSelected, "isTemporada", true )
									this.$set(program, "isTemporada", true )
								}

								if(dato.title == "N° del Capítulo" && dato.active) {
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										let color =  '#000099' 
										this.$set(program, "chapterColor", color )
									}else {
										this.$set(program, "chapterColor", dato.color )
									}
									this.$set(program, "IsCap", true )
								}

								if(dato.title == "Precio del Capítulo") {
									//  && dato.active
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										let color =  '#219653' 
										this.$set(program, "priceChapterColor", color )
									} else {
										this.$set(program, "priceChapterColor", dato.color )
									}
									this.$set(this.programSelected, "priceChapter", dato.active )
									this.$set(program, "priceChapter", dato.active )
								}

								if(dato.title == "Precio Por Pasada del Capítulo") {
									//  && dato.active
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										let color =  'rgb(8, 120, 18)' 
										this.$set(program, "pricePassChapterColor", color )
									}else {
									this.$set(program, "pricePassChapterColor", dato.color )									}									
									this.$set(this.programSelected, "pricePassChapter", dato.active )
									this.$set(program, "pricePassChapter", dato.active )
									console.log(program,this.programSelected)
								}

								if(dato.title == "Estado del capítulo" && dato.active) {
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										console.log(dato.color, 'dato.color 111')
										let color =  this.isLargometraje(typeOfContent) ? '#FF0000': '#000099'
										// let color =  program.chapters[0].rerun == true ? '#000099' :  ''
										let color2 = program.chapters[0].estreno == true ? '#FF0000' :  '#FF0000'
										this.$set(program, "rerunChapterColor", color )
										this.$set(program, "stateChapterColor", color2 )
									}
									else {
										console.log(dato.color, 'dato.color 222')
										this.$set(program, "stateChapterColor", dato.color)
										this.$set(program, "rerunChapterColor", dato.color )
									}
									this.$set(program, "Estado", true )
								}
								if(dato.title ==  'Estado Temporada' && dato.active) {
									if (dato.color == '#FFFFFF' ||  dato.color == null ) {
										let color =  '#FF0000'
										this.$set(program, "seasonStateColor", color )
									}
									else {
										this.$set(program, "seasonStateColor", dato.color)
									}
									this.$set(program, "EstTemp", true )
								}
							})

							let conditionalDays = daysSpecific(this.allDiasByProgram)
							if(this.allDiasByProgram.length >= 2 && saveDays.length == conditionalDays.length) {
								this.$set(this.programSelected, "generalNoteBoss", 	this.noteDiv(refTextArea, nota))
								this.$set(program, "generalNoteBoss", this.noteDiv(refTextArea, nota))
							} else {
								this.$set(this.programSelected, "noteDay", 	this.noteDiv(refTextArea, nota))
								this.$set(program, "noteDay", this.noteDiv(refTextArea, nota))
							}
						}
					})
				})		
			}
		},
		openModal(program) {
			this.programSelected = program.programPrincipal
			this.allDiasByProgram = program.programByDay
			this.modalInfo = true
			this.dayAutoSelect = setChooseDefaultDaySelect(program.programByDay)
		},
		closeModal() {
			this.modalInfo = false
		},
		addClassToProgramTitle (program) {
			let hasChapters = false
			if(!(program.programByDay.length > 1)){
				if(!(program.programByDay[0].material.numChapters.length > 0)){
					hasChapters = true
				}
			}
			return hasChapters
		},
		setWeek(){
			if (this.dateSearch === '' || this.dateSearch === null) { 
				this.firstDayOfWeek = getFirstDay(new Date())
				this.startDate = getFirstDay(new Date())
				this.firstDay = this.firstDayOfWeek.getDate();
				this.secondDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)).getDate()
				this.thirdDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*2).getDate()
				this.fourthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*3).getDate()
				this.fifthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*4).getDate()
				this.sixthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*5).getDate()
				this.lastDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6).getDate()
				this.endDate = new Date(this.startDate.setDate(this.startDate.getDate() + 6))  
				this.month = months[this.firstDayOfWeek.getMonth()];
				this.month2 = months[this.endDate.getMonth()];
				this.year = this.firstDayOfWeek.getFullYear();
				this.year2 = this.endDate.getFullYear();
			} else {
				this.firstDayOfWeek = getFirstDay(new Date(this.dateSearch));
				this.startDate = getFirstDay(new Date(this.dateSearch))
				this.firstDay = this.firstDayOfWeek.getDate();
				this.secondDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)).getDate()
				this.thirdDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*2).getDate()
				this.fourthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*3).getDate()
				this.fifthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*4).getDate()
				this.sixthDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*5).getDate()
				this.lastDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6).getDate()
				this.endDate = new Date(this.startDate.setDate(this.startDate.getDate() + 6))
				this.month = months[this.firstDayOfWeek.getMonth()];
				this.month2 = months[this.endDate.getMonth()];
				this.year = this.firstDayOfWeek.getFullYear();
				this.year2 = this.endDate.getFullYear();
			}

			if (this.month == this.month2 && this.year == this.year2  ) {
				this.dateString = `Semana del ${this.firstDay} al ${this.lastDay} de ${this.month} del ${this.year}`
			} else if (this.month !== this.month2 && this.year == this.year2 ) {
				this.dateString = `Semana del ${this.firstDay} de ${this.month} al ${this.lastDay} de ${this.month2} del ${this.year}`
			} else if (this.month !== this.month2 && this.year !== this.year2) {
				this.dateString = `Semana del ${this.firstDay} de ${this.month} del ${this.year} al ${this.lastDay} de ${this.month2} del ${this.year2}`
			}
		},
		returnPage () {
		  let filterOnlyPrograms = []
			this.orderByProgram.map((program, i, arr) => {
				program.programByDay.map((programDay, y, arr) => {
				filterOnlyPrograms.push(programDay)
				})
			})

			let dataModifi = JSON.stringify(filterOnlyPrograms) 
			let dataOriginal = this.$localStorage.get("dayToCopy")
			if (dataModifi == dataOriginal ) {
				this.$router.push({ name: 'views'})
			}
			else {
				this.returnButtonModal = true
			}
		},
		async getWeek (weekSelect) {
			this.orderByProgram = []
			this.idOfPrograms = []
			const responseText = "Week not found weekDate"
    		const responseHTTP = await HTTP.post('grid/filterWeek',{week:weekSelect});
			const coincidence = responseHTTP.data.ok? responseHTTP.data.grid : responseText;

			if(coincidence && coincidence !== responseText) {
				this.orderByProgram = []
				this.dataAllWeek = coincidence
				const { programs, approvedWeek } = coincidence
				this.allProgramsWithGrid = coincidence
				if(approvedWeek) {
					/*FILTRO POR CANAL DE TRANSMISION*/
					let isTrue = false
        	let programsByChannel = []
					programs.map((program)=>{
						if(program.refProgram.checkedChanels.length > 0){
							program.refProgram.checkedChanels.map((channel)=> {
								if(channel.toLowerCase() == this.chanelTransmission.toLowerCase()){
									programsByChannel.push(program)
								}
							})
						} else {
							programsByChannel.push(program)
						}
					})
						
					// RECORRE LA DATA QUE TRAE LA RESPUESTA
					programsByChannel.map((program)=>{
						const {refProgram: {_id}} = program
						const object = {
							programPrincipal: this.modelPrincipalProgram(program),
							programByDay: [modelProgramByDay(program)]
            			}
            
            			//aqui modificar si se quiere cambiar a madrugada 

						if(this.idOfPrograms.includes(_id) == false){
							// INSERTA LOS PROGRAMAS SI SUS ID'S NO HAN SIDO INSERTADOS ANTERIORMENTE
							this.idOfPrograms.push(_id)
							this.orderByProgram.push(object)
						} else {
							const {refProgram: {codeDays}} = program

							let arrSamePrograms = []
							this.orderByProgram.map((program, index)=>{
								if(program.programPrincipal._id == _id){
									arrSamePrograms.push(index)
								}
							})
							
							let daySelected = this.getDayCode(program.completeDate)
							
							let addToProgram = false
							//RECORRE EL ARRAY DE PROGRAMAS QUE SE HAN CREADO PERO QUE PERTENECEN AL MISMO PROGRAMA
							for(let i=0; i<arrSamePrograms.length; i++){
								let programSelected = this.orderByProgram[arrSamePrograms[i]]
								let daysSaved = []
								//GUARDA EN UN ARRAY LOS DIAS QUE SE HAN GUARDADO EN EL PROGRAMA
								programSelected.programByDay.map((programDay)=>{
									const day = programDay.completeDate
									const daySaved = this.getDayCode(day)
									daysSaved.push(daySaved)
								})
								
								//RECORRE LOS DIAS DEL PROGRAMA 
								codeDays.map((day, index)=>{
									//VERIFICA EL DIA SELECCIONADO
									if(day == daySelected){
										//SI ES DOMINGO SE CAMBIA A 8 PORQUE CON EL 1 NO VALIDA CORRECTAMENTE
										daySelected = (daySelected == 1)? 8: daySelected
										//VALIDA SI EL DIA SELECCIONADO ES CORRELATIVO EN EL ARRAY DE DIAS DEL PROGRAMA
										if(codeDays.includes(daySelected-1) || codeDays.includes(daySelected+1)){
											//RECORRE LOS DIAS DEL PROGRAMA YA INGRESADOS
											daysSaved.map((savedDay)=>{
												//VERIFICA QUE EL DIA SELECCIONADO SEA CORRELATIVO A LOS DIAS QUE YA ESTAN INGRESADOS
												if(savedDay == (daySelected-1) || savedDay ==  (daySelected+1)){
													// VERIFICA QUE LOS DIAS CONTENGAN EL MISMO HORARIO
													const indexArrProgram = programSelected.programByDay.length -1
													const lastProgram = programSelected.programByDay[indexArrProgram]
													const programByDay = modelProgramByDay(program)
													
													let lastProgramTimeStart = this.convertToMinutes(lastProgram.scheduleStartHour, lastProgram.scheduleStartMin)
													let lastProgramTimeEnd = this.convertToMinutes(lastProgram.scheduleEndHour, lastProgram.scheduleEndMin)

													let programSelectedTimeStart = this.convertToMinutes(programByDay.scheduleStartHour, programByDay.scheduleStartMin)
													let programSelectedTimeEnd = this.convertToMinutes(programByDay.scheduleEndHour, programByDay.scheduleEndMin)

													if((lastProgramTimeStart == programSelectedTimeStart) && (lastProgramTimeEnd == programSelectedTimeEnd)){
														addToProgram = true
														programSelected.programByDay.push(modelProgramByDay(program))
													} else {
														addToProgram = false
													}
												}
											})
										}
									}
								})
							}

							//AGREGA COMO NUEVO PROGRAMA SI NO ES UN DIA CORRELATIVO
							if(addToProgram == false){
								this.orderByProgram.push(object)
							}
						}
					})
				}		
			}
			this.orderByProgram = this.sortByHour(this.orderByProgram)
			// console.log(this.orderByProgram , 'this.orderByProgram ')
      this.fillingGrid(this.orderByProgram)
      // GUARDANDO COPIA DE LA PARRILLA ORIGINAL PARA COMPARARLO CUANDO RETORNE A LA VISTA ANTERIOR 
      let filterOnlyPrograms = []
      this.orderByProgram.map((program, i, arr) => {
        program.programByDay.map((programDay, y, arr) => {
          filterOnlyPrograms.push(programDay)
        })
      })
      this.$localStorage.set('dayToCopy', JSON.stringify(filterOnlyPrograms))
		},
		modelPrincipalProgram(program){
			let exitMaterialReferencia = program.materialReferencia ? program.materialReferencia.typeOfContent : ''
			let conditionalTypeOfContent = program.typeOfContent ? program.typeOfContent : exitMaterialReferencia
			const programPrincipal = {
				_id: program.refProgram._id,
				arrCheckCrosses: program.refProgram.arrCheckCrosses,
				checkedChanels: program.refProgram.checkedChanels,
				checkedSignals:program.refProgram.checkedSignals ,
				codProgram: program.refProgram.codProgram,
				codeDays: program.refProgram.codeDays,
				geminisCode: program.refProgram.geminisCode,
				programTitle: program.refProgram.programTitle,
				scheduleEndHour: program.scheduleEndHour,
				scheduleEndMin: program.scheduleEndMin,
				scheduleStartHour: program.scheduleStartHour,
				scheduleStartMin: program.scheduleStartMin,
				transmissionDays: program.refProgram.transmissionDays,
				classification: program.classification,
				isTemporada: program.isTemporada  || false,
				isClasification: program.isClasification || false,
				clasificationColor: program.clasificationColor,
				seasonColor: program.seasonColor,
				isUnitPrice: program.isUnitPrice  || false,
				unitPriceColor: program.unitPriceColor,
				generalNote: program.generalNote,
				IsCodProvider: program.IsCodProvider  || false,
				providerCode: program.providerCode,
				transmissionDaysDescription: this.dayStartAndDayEnd(program.refProgram.transmissionDays),
				typeOfContent: conditionalTypeOfContent,
				materialTitle: program.materialTitle,
				materialHasChapter: program.materialHasChapter,
				materialType: program.materialType,
				firstActor: program.firstActor,
				secondActor: program.secondActor,
				unitPrice: program.unitPrice,
				season: program.season,
				stringMaterialType: program.stringMaterialType,
				codeFeatureFilm: program.codeFeatureFilm,
				materialExisting: program.materialExisting,
				material: program.material,
				generalNoteBoss: program.generalNoteBoss,
				materialReferencia: program.materialReferencia,
				material: program.material,
				programDate: program.programDate,
				Estado: program.Estado,
				priceChapter: program.priceChapter,
				pricePassChapter: program.pricePassChapter,
				codProviderColor: program.codProviderColor
			}
			return programPrincipal
		},
		convertToMinutes(hours, minutes){
			const result = (hours * 60) + minutes
			return result
		},
		sortByHour(programs) {
			return programs.slice().sort(function(a, b) {
				//SE ORDENA POR TOTAL DE MINUTOS
				const firstProgramMinutesTotal = (a.programPrincipal.scheduleStartHour * 60) + a.programPrincipal.scheduleStartMin
				const secondProgramMinutesTotal = (b.programPrincipal.scheduleStartHour * 60) + b.programPrincipal.scheduleStartMin
				
				return firstProgramMinutesTotal - secondProgramMinutesTotal;
			});
		},
		getDayCode (day){
			let daySelected = day.split(' ')[0]
			let dayCode = ''
			switch(daySelected){
				case 'Lunes':
					dayCode = 2
				break;
				case 'Martes':
					dayCode = 3
				break;
				case 'Miércoles':
					dayCode = 4
				break;
				case 'Jueves':
					dayCode = 5
				break;
				case 'Viernes':
					dayCode = 6
				break;
				case 'Sábado':
					dayCode = 7
				break;
				case 'Domingo':
					dayCode = 1
				break;
			}

			return dayCode
		},
		addingZerosToTheDay (day) {
			if(String(day).length < 2){
				day = '0'+ day
			}
			return day
		},
	  	fillingGrid (data) {
			let programs = data
			this.contentHtml = ''
			programs.map((program, index) => {
				let template = ''
				const nameProgram = program.programPrincipal.programTitle	
				const arrDays = program.programByDay.map((e)=> (this.getDayCode(e.completeDate) == 1)?8:this.getDayCode(e.completeDate))
				const daysInOrder = arrDays.sort()
				let hourStart = program.programPrincipal.scheduleStartHour
				let hourEnd = program.programPrincipal.scheduleEndHour
				let minEnd = program.programPrincipal.scheduleEndMin
	      let minStart = program.programPrincipal.scheduleStartMin

        if (hourStart <5 ) {
          hourStart = Number(hourStart) + 24
        }
        else if (hourStart == 5 && hourEnd !== 5 && minStart != 16 && minEnd == 16 ) {
          hourStart = Number(hourEnd) + 24
        }
        
        if (hourEnd <5) {
          hourEnd = Number(hourEnd) + 24
        } 
        else if (hourEnd == 5 && minEnd<=16) {
          hourEnd = Number(hourEnd) + 24
        }

        const totalMinutesStart = (Number(hourStart)*60) + Number(program.programPrincipal.scheduleStartMin)
        const totalMinutesEnd = (Number(hourEnd)*60) + Number(minEnd)
        let initGrid = Math.round(totalMinutesStart/5 - 63.2)
        let finalGrid = Math.round(totalMinutesEnd/5 - 63.2)
        const concatGrid = (initGrid+1) +' / '+ (daysInOrder[0]-1) + ' / span '+ (finalGrid - initGrid) + ' / ' + (daysInOrder[(daysInOrder.length)-1])

        template = `<div class="grid-programsByDay" style="grid-area: ${concatGrid};">
                ${nameProgram}
              </div>`
        this.contentHtml += template
        let divObj = 'cell-'+index
        this.$refs[divObj] && this.$refs[divObj][0] ? this.$refs[divObj][0].style.gridArea = concatGrid : ''
			})
		},
		dayStartAndDayEnd(val) {
			if(val && val.length > 1) {
				const counter = val.length
				const connect = val[0] == 'Lunes' ? 'a' : 'y'
				// const connect =  'y'
				const counterCondicional = connect == 'a' ? 5 : 2
				// const counterCondicional = 5
				// const text = `${val[0]} ${connect} ${val[counter-1]}`
				const text = 'Lunes y Martes'
				return {
					text,
					value: counterCondicional
				}
			} else if(val && val.length == 1) {
				return {
					text: val[0],
					value: 1
				}
			}
		},
		/*___________________Métodos para crear el array de las horas ____________________*/
		getTime(firstTime, secondTime, operator) {
			const secs1 = this.stringToSeconds(firstTime)
			const secs2 = this.stringToSeconds(secondTime)
			let secsDif
			if(operator == 'sum') {
				secsDif = secs1 + secs2
			} else {
				if(secs1 > secs2) {
					secsDif = secs1 - secs2
				} else {
					secsDif = secs2 - secs1
				}
			}
			// const secsDif = operator == 'sum' ? (secs1 + secs2) : (secs1 - secs2)
			return this.secondsToTime(secsDif)
    	},
		stringToSeconds(tiempo) {
			let sep1 = tiempo.indexOf(":")
			let sep2 = tiempo.lastIndexOf(":")
			let hor = tiempo.substr(0, sep1)
			let min = tiempo.substr(sep1 + 1, sep2 - sep1 - 1)
			return Number(min) * 60 + Number(hor) * 3600
		},
		secondsToTime(secs) {
			let hor = Math.floor(secs / 3600)
			let min = Math.floor((secs - hor * 3600) / 60)
			let sec = secs - hor * 3600 - min * 60
			// return this.padNmb(hor, 2) + ":" + this.padNmb(min, 2)
			return (
				this.padNmb(hor, 2) +
				":" +
				this.padNmb(min, 2) +
				":" +
				this.padNmb(sec, 2)
			)
		},
		padNmb(nStr, nLen) {
			const sRes = String(nStr)
			const sCeros = "0000000000"
			return sCeros.substr(0, nLen - sRes.length) + sRes
		},
		recordArray(firstTime, secondTime, operator, record) {
			const arr = [firstTime]
			for (let i = 0; i < record; i++) {
				arr.push(this.getTime(arr[i], secondTime, operator));
			}
			return arr
		},
		formatedArray() {
			const b = this.recordArray("05:30:00", "00:15:00", 'sum', 74).concat(this.recordArray("00:15:00", "00:15:00", 'sum', 19))
			const c = b.unshift("05:16:00")
			const d = b.map((e) => e.slice(0, 5))
			return d
		},
		isHaveClassification(val) {
			let value
			if(val) {
				value = `(${val})`
			} else {
				value = ''
			}
			return value
		},
		noteDiv(classAsigned, nota) {
			const reviewClass = classAsigned.replace('el-textarea__inner', '') 
			const classSelect = reviewClass.replace('textarea-style', '')
			const template = nota && nota !== ''? `<div><p class="${classSelect}">${nota}</p></div>` : ''
			return template
		},
		isHaveActors(val) {
			let value, arr
			if(val && val.artisticInfo) {
				let exitsActors = val.artisticInfo.length > 0 ? val.artisticInfo[0].mainActors : []
				let counterActors = exitsActors.length
				if(counterActors > 2) {
					arr = [exitsActors[0], exitsActors[1]]
				} else {
					arr = exitsActors
				}
				value = arr
			}
			return value
		},
		cancelModal() {
			this.modalInfo = false
		},
		printPage() {
			sessionStorage.setItem('orderByProgram', JSON.stringify(this.orderByProgram))
			sessionStorage.setItem('allProgramsWithGrid', JSON.stringify(this.allProgramsWithGrid))
			sessionStorage.setItem('dateString', JSON.stringify(this.dateString))
			sessionStorage.setItem('firstDay', JSON.stringify(this.firstDay))
			sessionStorage.setItem('secondDay', JSON.stringify(this.secondDay))
			sessionStorage.setItem('thirdDay', JSON.stringify(this.thirdDay))
			sessionStorage.setItem('fourthDay', JSON.stringify(this.fourthDay))
			sessionStorage.setItem('fifthDay', JSON.stringify(this.fifthDay))
			sessionStorage.setItem('sixthDay', JSON.stringify(this.sixthDay))
			sessionStorage.setItem('lastDay', JSON.stringify(this.lastDay))
			// this.$router.replace({ name: 'viewPrint' })
			// { name: 'viewPrintJefatura', params: {grid: 'jefatura'}}
			this.$router.push({ name: 'viewPrintJefatura', params: {grid: 'jefatura'}})
		},
		saveGrid() {
			let filterOnlyPrograms = []
			this.orderByProgram.map((program, i, arr) => {
				program.programByDay.map((programDay, y, arr) => {
					filterOnlyPrograms.push(programDay)
				})
			})
			console.log(filterOnlyPrograms, 'filterOnlyPrograms')

			HTTP.patch('grid/update/' + this.dataAllWeek._id, [{
				propName: "programs", value: filterOnlyPrograms
			}])
			.then(res => {
				this.modalGuardar = true
				this.$store.dispatch('getData', 'grid')
				// console.log('se hizo patch a GRID')
			})
			.catch(err => console.log(err));
		},
		calculateScheduleHours(scheduleStartHour, scheduleStartMin) {
			return calculateSchedule(scheduleStartHour, scheduleStartMin)
		},
		calculateTime(val) {
			const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin, programTitle} = val
			
			let timeStartProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleStartHour, scheduleStartMin), val.programDate, 'start' )
			let timeEndProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleEndHour, scheduleEndMin), val.programDate, 'end' )
			
			let timeStart = new Date(String(timeStartProgramCardsData)).getTime()
			let timeEnd = new Date(String(timeEndProgramCardsData)).getTime()
			let hourDiff = timeEnd - timeStart
			let secDiff = hourDiff / 1000
			let minDiff = hourDiff / 60 / 1000
			let hDiff = hourDiff / 3600 / 1000
			let result = {}
			result.hours = Math.floor(hDiff)
			result.minutes = minDiff - 60 * result.hours
			
			let response =  `${this.calculateHour(String(result.hours))}:${this.calculateHour(String(result.minutes))}:00`
			return response
		},
		conditionalDate(val) {
			let getTime = val.split(":")
			let getHour = String(getTime[0])
			let hour = this.calculateHour(getHour)
			let getMin = String(getTime[1])
			let min = this.calculateHour(getMin)
			let conditionalHour = hour === '00' ? '24' : hour
			// let time = val == '00:00' ? '24:00:00' : `${hour}:${min}:00`
			let time = `${conditionalHour}:${min}:00`
			return time
		},
		calculateHour(hour) {
			return hour.length == 2 ? hour : `0${hour}`
		},
		durationProgramTitle(program) {
			const data = this.calculateTime(program.programPrincipal)
			let conditional = program.programByDay.length == 1 ? true : false
			const {programTitle, materialTitle, typeOfContent} = program.programPrincipal
			let time
			if(conditional) {
				let oneWord = materialTitle.split(' ')
				if(oneWord.length == 1) {
					if(typeOfContent == 'Largometrajes' || typeOfContent == 'LARGOMETRAJES') {
						time = materialTitle.length >= 10 ? 'font-size-18' : 'font-size-22'
					} else {
						let setStyle = this.isLargometraje(typeOfContent) ? 'p-i-0 width_auto m-i-0' : 'p-i-0 width_auto'
						time = this.stylesForProgramTitle(data, conditional, programTitle, setStyle)
					}
				} else {
					let setStyle = this.isLargometraje(typeOfContent) ? 'p-i-0 width_auto m-i-0' : ''
					time =  this.stylesForProgramTitle(data, conditional, programTitle, setStyle)
				}
			} else {
				time = this.stylesForProgramTitle(data, conditional, programTitle)
			}
			return time
		},
		stylesForProgramTitle(data, conditional, programTitle, extraStyle) {
			let time
			if(data <= '00:00:00' ) {
				time = conditional ? sizeLetttersAboutProgramCompare(programTitle, 'font-size-15', 'font-size-18 text-end' ,14) : sizeLetttersAboutProgramCompare(programTitle, 'font-size-15', 'font-size-18' ,14)
			} else if(data <= '00:05:00') {
				time = conditional ? sizeLetttersAboutProgramCompare(programTitle, 'letters-small font-size-10', 'letters-small font-size-15 text-end' ,14) : sizeLetttersAboutProgramCompare(programTitle, 'letters-small font-size-10', 'letters-small font-size-15' ,14)
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = 'font-size-14 t-5 font-weight-0'
			} else if(data > '00:15:00' && data <= '00:30:00') {
				// time = 'font-size-14 font-weight-0'
				time = programTitle.length <= 14 ? 'font-size-14 font-weight-0' : 'font-size-14 font-weight-0 m-i-0'
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = 'font-size-18'
			} else {
				time = 'font-size-24'
			}
			return extraStyle ? `${time} ${extraStyle}` : time
		},
		durationProgramTitleLargometraje(val) {
			const {programTitle} = val
			const data = this.calculateTime(val)
			let time
			if(data <= '00:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-8', 'size-10')
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgram(programTitle, 'size-10', 'font-size-12')
			} else if(data > '01:00:00' && data <= '01:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-12', 'font-size-14')
			} else {
				time = 'font-size-15'
			}
			return time
		},
		durationProgramHeader(program) {
			const {programTitle} = program[0]
			const data = this.calculateTime(program[0])
			let conditional = program.length == 1 ? true : false
			let time
			if(conditional && (data <= '00:10:00'|| data == '00:00:00' )) {
				return programTitle && programTitle.length <= 14 ? 'font-size-10 p-0' : 'hidden'
			} else {
				if(data < '00:10:00') {
					time = programTitle && programTitle.length >= 14 ? 'hidden' : 'font-size-12 p-0'
				} else if(data >= '00:10:00' && data <= '00:15:00') {
					time = 'font-size-14 p-0'
				} else if (data > '00:15:00' && data <= '00:45:00') {
					time = 'font-size-16 p-0'
				} else {
					time = 'font-size-17'
				}
				return time
			}
		},
		durationProgramHeaderIcon(program) {
			const data = this.calculateTime(program[0])
			const {programTitle} = program[0]
			let time
			let conditional = program.length == 1 ? true : false
			if(conditional && (data <= '00:10:00'|| data == '00:00:00' )) {
				return 'hidden'
			} else {
				if(data < '00:20:00' || data == '00:00:00') {
					// time = programTitle && programTitle.length >= 14 ? 'hidden': 'bg-icon-small font-size-12'
					time = 'hidden'
				} else if (data >= '00:20:00' && data <= '00:45:00') {
					time = 'font-size-20 bg-icon-middle'
				} else {
					time = 'font-size-28 bg-icon'
				}
				return time
			}
		},
		generateDays() {
			const days = [
				{
					name: 'Lunes',
					number: addingZerosToTheDay(this.firstDay),
				},
				{
					name: 'Martes',
					number: addingZerosToTheDay(this.secondDay),
				},
				{
					name: 'Miercoles',
					number: addingZerosToTheDay(this.thirdDay),
				},
				{
					name: 'Jueves',
					number: addingZerosToTheDay(this.fourthDay),
				},
				{
					name: 'Viernes',
					number: addingZerosToTheDay(this.fifthDay),
				},
				{
					name: 'Sábado',
					number: addingZerosToTheDay(this.sixthDay),
				},
				{
					name: 'Domingo',
					number: addingZerosToTheDay(this.lastDay),
				}
			]
			return days
		}
	},
	created () {
		this.setWeek()
		// window.addEventListener('scroll', this.handleScroll);
		this.timeForDay = this.formatedArray()
	},
	computed: {
		...mapGetters([
			'filterForWeek'
		]),
		isDisabledBtn() {
			return this.orderByProgram.length > 0 ? false : true
    },
  	styleBtnAproved() {
    	let obj = {}
			if(this.orderByProgram.length > 0 && this.dataAllWeek.approvedWeek) {
				obj.name ='APROBADO'
				obj.status = true
				obj.isShow = false
			} else {
				obj.name ='APROBAR'
				obj.status = this.isDisabledBtn
				obj.isShow = true
			}
			return obj
		}
	},
	watch: {
		dateString:{
			handler(newVal, oldVal){
				if(newVal !== ''){
					this.getWeek(newVal)
				}
			},
			deep: true
		},
		modalInfo(val) {
			if(val == false) {
				this.$refs.modalComponent.resetModal()
			} else {
				this.$refs.modalComponent ? this.$refs.modalComponent.restoreClassInNote() : ''
			}
		},
		// weekSelect(val) {
		// 	console.log('weekSelect', val)
		// }
	},
	updated(){
		if(this.orderByProgram.length > 0){
			this.fillingGrid(this.orderByProgram)
		}
	}
}
</script>

<style>
	.grid-weekDays {
		display: grid;
		/* grid-template-columns: repeat(auto-fit, minmax(320px, 7)); */
		grid-template-columns: repeat(7, 170px);
		border: 3px #000099 solid;
		align-items: center;
	}
	.grid-days {
		background: #FF7333;
		color: white;
		font-weight: 500;
		font-size: 18px;
		text-align: center;
		text-transform: uppercase;
		padding: 8px 0;
	}
	.textCollapse {
		display: block;
	}
	.grid-programs {
		display: grid;
		background: #fdc2a7;
		grid-template-columns: repeat(7, 170px);
		grid-template-rows: repeat(288, 20px);
		border-left: 3px #000099 solid;
		border-right: 3px #000099 solid;
	}
	.grid-byProgram {
		position: relative;
		border: 1.5px solid #000099;
		background: white;
	}
	.programDuration {
		background: #FFDCCC;
		padding: 4px 8px;
	}
	.el-checkbox.programCheck {
		position: absolute;
		right: 0;
		top: 0;
		padding: 8px 10px;
	}
	.el-checkbox.programCheck .el-checkbox__inner {
		width: 18px;
		height: 18px;
	}
	.el-checkbox.programCheck .el-checkbox__inner::after {
		border: 1.5px solid #fff;
		height: 10px;
		left: 6px;
		border-left: 0;
		border-top: 0;
	}
	.principalTitle {
		font-weight: 700;
		text-transform: uppercase;
		text-align: center;
		top: 25px;
		margin-top: 10px;
		padding: 0 10px;
		margin-bottom: 5px;
		color: black;
		z-index: 10;
		position: relative;
		width: calc(100% - 21px);
	}
	.statusText {
		text-transform: uppercase;
		color: #FF7333;
		font-weight: 500;
		font-size: 15px;
		text-align: center;
	}
	/*Sticky navbar*/
	.sticky {
		position: fixed;
		top: 99px;
		width: auto;
		z-index: 1000;
	}
	.sticky + .grid-programs {
		margin-top: 17px;
	}
	.sticky + .box_style {
		margin-top: 17px;
	}
	.boxAllDays{
		display: grid;
		position: absolute;
		bottom: 0;
		width: 100%;
		grid-template-columns: repeat(7, 170px);
		height: 100%;
	}
	.boxByChapter {
		display: inline-block;
		font-weight: 600;
		width: calc(100% - 10px);
		text-align: center;
		padding: 0 5px 5px;
		z-index: 10;
		position: relative;
		width: 100%;
	}
	.boxByDay {
		font-size: 16px;
		font-weight: 500;
		position: relative;
	}
   
	.boxDataByChapter{
		display: inline-block;
	}
	.statusByChapterText{
		text-transform: uppercase;
    	font-weight: 600;
	}
	.titleWitoutChapters{
		text-transform: uppercase;
		color: #FF5000;
		font-weight: 500;
		font-size: 13px;
	}
	.clasBtnCircle {
		width: '25px';
		height: '25px';
	}
 	.grid-schedule-title {
		display: grid;
		grid-auto-rows: minmax(55px, auto);
		border-top: 3px #000099 solid;
    	border-bottom: 3px #000099 solid;
		align-items: center;
		color: #FFFF;
		background-color: #FF7333;
		grid-template-columns: repeat(1, 55px);
		text-align: center;
		font-weight: 500;
  	}
	.grid-schedule {
		display: grid;
		border-bottom: 3px #000099 solid;
		grid-auto-rows: minmax(39px, auto);
		align-items: center;
		text-align: center;
		background: #FF7333;
		color: white;
		font-weight: 500;
		font-size: 18px;
	}
	.grid-schedule-content {
		display: grid;
		grid-template-rows: repeat(60, 4px);
		border-left: 2px #000099 solid;
	}
	.borderGray {
		border: 1px solid #A7A7A7;
	}
	.borderOrange {
		border: 1px solid #FF5000;
	}
	.box_style {
		display: grid;
		grid-template-rows: repeat(288, 20px);
	}
	.box_style_border_rigth {
		border-right: 3px #000099 solid;
	}
	.box_style_border_left {
		border-left: 3px #000099 solid;
	}
	.note {
		text-align: center;
		padding-bottom: 5px;
		font-weight: initial;
		color: initial;
	}
	.noteAllDay {
		display: grid;
		position: absolute;
		bottom: 50%;
		width: 100%;
	}
	.textBold {
		font-weight: bold;
	}
	.textUnderline {
		text-decoration-line: underline;
	}
	.textItalic {
		font-style: italic;
	}
	.upperCase {
		text-transform: uppercase;
	}
	.lowerCase {
		text-transform: lowercase;
	}
	.redColor {
		color: #FF0000 !important;
	}
	.blueColor {
		color: #000099 !important;
	}
	.blackColor {
		color: #262626 !important;
	}
	.btn-style-note {
		width: 20px;
		height: 20px;
		border-radius: 2px;
    	border: 1px solid #A7A7A7;
		margin: 0 2.5px;
		color: #A7A7A7;
		background-color: #FFFF;
	}
	.i-style-note {
		top: 1px;
    	position: relative;
	}
	.space-special-botton {
		margin: 0 2.5px;
	}
	.special-botton-style {
		display: inline-block;
		height: 19px !important;
		border: 1px solid #A7A7A7;
		color: #A7A7A7;
		border-radius: 2px;
		width: 20px;
	}
	.justify-content-center {
		justify-content: center;
	}
	.justify-content-space {
		justify-content: space-evenly;
		align-items: center;
	}
	.box-buttons {
		border: 1px solid #A7A7A7;
		padding: 3px;
		width: 60%;
		border-top-left-radius: 4px;
		border-top-right-radius: 4px;
		border-bottom: none;
	}
	.textarea-style {
		border: 1px solid#A7A7A7 !important;
		border-top-left-radius: 0px !important;
		height: 65px !important;
		min-height: 65px !important;
	}
	.btn-color-text {
		border-radius: 100%;
		width: 15px;
		height: 15px;
		margin: 5px 0px;
	}
	.bg-redColor {
		background-color: #FF0000 !important;
	}
	.bg-blueColor {
		background-color: #000099 !important;
	}
	.bg-blackColor {
		background-color: #262626 !important;
	}
	.general-note-style {
		font-weight: initial;
    	text-transform: initial;
	}
	.bg-icon-style {
		background-color: #FFFF;
		border-radius: 100%;
		margin-top: 1px;
	}
	.bg-icon {
		width: 23px;
		height: 23px;
		margin-left: 1px;
	}
	.bg-icon-middle {
		width: 17px;
		height: 17px;
	}
	.btn-gray-save {
		background-color: #C4C4C4 !important;
		border: 2px solid #C4C4C4 !important;
		color: #FFFF !important;
	}
	.btn-gray-save:hover {
		background-color: #FFFF !important;
		color: #C4C4C4 !important;
	}
	.padding-right-5 {
		padding-right: 5px;
	}
	.padding-left-5 {
		padding-left:5px;
	}
	.contentBoxByChapter {
		display: flex;
		flex-wrap: wrap;
		position: absolute;
		bottom: -3px;
		/* bottom: 0; */
		border-right: 1px solid gray;
		justify-content: center;
		width: 100%;
		box-sizing: border-box;
	}
	.rezise-box {
		max-height: 60%;
		white-space: nowrap;
		overflow: hidden;
		text-overflow: ellipsis;
		resize: horizontal;
	}  
	.title {
		font-weight: 700;
		font-size: 17px;
		color: #000099;
		text-transform: uppercase;
	}
	.hidden {
		display: none !important;
	}
	.position-z-index {
		position: absolute;
		width: 100%;
		z-index: 20;
		/* z-index: 10; */
	}
	.letters-small {
		position: absolute;
		margin: 0 !important;
		top: 20%;
		transform: translateY(10%);
	}
	.letters-middle {
		font-size: 12px !important;
	}
	.letters-big {
		font-size: 24px !important;
	}
	.font-size-11 {
		font-size: 11px !important;
	}
	.font-size-14 {
		font-size: 14px !important;
	}
	.font-size-15 {
		font-size: 15px !important;
	}
	.font-size-25 {
		font-size: 25px !important;
	}
	.font-size-18 {
		font-size: 18px !important;
	}
	.font-weight-0 {
		font-weight: lighter;
	}
	.margin-0 {
		margin: 0 !important;
	}
	.box-middle {
		display: flex;
		position: absolute;
		/* top: 78px; */
		top: 83px;
	}
	.margin-b-25 {
		margin-bottom: 25px
	}
	.margin-t-1 {
		margin-top: 1rem;
	}
	.margin-t-1-2 {
		margin-top: 0.5rem;
	}
	.margin-t-5 {
		margin-top: 5px !important;
	}
	.note-style-middle {
		font-size: 10px;
		word-break: break-all;
		padding: 0 10px;
		display: flex;
    	justify-content: center;
	}
	.padding-0-10 {
		padding: 0 10px;
	}
	.ellipsis-text {
		white-space: nowrap;
		overflow: hidden;
		text-overflow: ellipsis;
	}
	.work-break {
		word-break: break-word;
	}
	.p-relative {
		position: relative;
	}
	.t-18 {
		top: 18px;
	}
	.b-25 {
		bottom: 25px;
	}
	.p-absolute {
		position: absolute;
	}
	.t-0 {
		top: 0;
	}
</style>
